/*************************************************************************/
/*                                                                       */
/*  libservices - /etc/services handling library.                        */
/*                                                                       */
/*  Written by Gustavo Niemeyer <gustavo@niemeyer.net>                   */
/*                                                                       */
/*  Copyright (C) 2001 Conectiva, Inc.                                   */
/*                                                                       */
/*  This library is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU Library General Public          */
/*  License as published by the Free Software Foundation; either         */
/*  version 2 of the License, or (at your option) any later version.     */
/*                                                                       */
/*  This library is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    */
/*  Library General Public License for more details.                     */
/*                                                                       */
/*  You should have received a copy of the GNU Library General Public    */
/*  License along with this library; if not, write to the                */
/*  Free Software Foundation, Inc., 59 Temple Place - Suite 330,         */
/*  Boston, MA  02111-1307, USA.                                         */
/*                                                                       */
/*************************************************************************/
#ifndef libservices_h
#define libservices_h

enum {
  SERV_NEW = 1,
  SERV_REMOVED
};

struct serv_alias {
  struct serv_alias *prev, *next;
  char *alias;
};

struct serv {
  struct serv *prev, *next;
  char *name;
  struct serv_alias *aliases;
  char *proto;
  char *port;
  char *comments;
  int flags;
};

struct serv *serv_create_new();
struct serv *serv_load(const char *filename);
int serv_write(const char *filename, struct serv *serv_list);
int serv_add(struct serv *serv_list, struct serv *serv_new);
int serv_has_alias(const struct serv *serv, const char *alias);
int serv_match_any_alias(const struct serv_alias *first,
                         const struct serv_alias *second);
void serv_destroy(struct serv *serv_list);
void serv_destroy_aliases(struct serv_alias *aliases);

#endif /* libservices_h */

/* vim:sw=2:ts=2:et
*/
